<?
// +-----------------------------------------------------------------+
// | AGATA Report                                                    |
// | Copyleft (l) 2002  UNIVATES Lajeado/RS - Brasil                 |
// +-----------------------------------------------------------------+
// | Licensed under GPL: www.fsf.org for further details             |
// |                                                                 |
// | Site:   http://agata.codigoaberto.org.br                        |
// +-----------------------------------------------------------------+
// | Abstract: Graphical tool, written in PHP-GTK that allows        |
// |       to edit and getting SQL results from PostgreSQL Database. |
// |                                                                 |
// | Created at August, 10, 2001                                     |
// | Created by Pablo Dall'Oglio  (pablo@univates.br, pablo@php.net) |
// +-----------------------------------------------------------------+

include_once 'classes/AgataCore.class';
include_once 'classes/Dialog.class';
include_once 'classes/Trans.class';
include_once 'classes/Grid.class';
include_once 'classes/pslib.class';
include_once 'classes/InputBox.class';
include_once 'classes/Alist.class';
include_once 'classes/FormEntry.class';
include_once 'classes/MultiFormEntry.class';
include_once 'classes/Label.class';
include_once 'classes/2list.class';
include_once 'classes/match.class';
include_once 'classes/Wait.class';
include_once 'classes/in.class';

include_once 'config.php';
include_once 'common.php';
include_once 'Main.php';

if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN')
  dl('php_gtk.dll');
else
  dl('php_gtk.so');

class AgataMain extends AgataCore
{
  var $aCheckVars;
  var $aAgataConfig;
  var $aLang;

  function AgataMain($aAgataConfig, $aDescription, $setupScreenLanguage)
  {
    $aLang  = array('en', 'pt', 'de', 'fr', 'it', 'se');
    $aDB    = array('pgsql','mysql','oracle','sybase','mssql','fbsql', 'ibase', 'ifx', 'odbc');
    
    $aTheme = array_merge('No theme', $this->GetDirArray('./themes'));
    $Projects = array_keys($aAgataConfig);
    $this->setupScreenLanguage = $setupScreenLanguage;
    
    Trans::SetLanguage($setupScreenLanguage);
    
    foreach ($Projects as $project)
    {
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['Project'],    Trans::Translate($aDescription['Project']),    false, null, false);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['LoginHOST'],  Trans::Translate($aDescription['LoginHOST']),  false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['LoginDB'],    Trans::Translate($aDescription['LoginDB']),    false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['LoginUID'],   Trans::Translate($aDescription['LoginUID']),   false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['LoginPWD'],   Trans::Translate($aDescription['LoginPWD']),   true,  null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['Language'],   Trans::Translate($aDescription['Language']),   false, $aLang, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['DataBase'],   Trans::Translate($aDescription['DataBase']),   false, $aDB, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['Theme'],      Trans::Translate($aDescription['Theme']),      false, $aTheme, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['PsSoft'],     Trans::Translate($aDescription['PsSoft']),     false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['TxtSoft'],    Trans::Translate($aDescription['TxtSoft']),    false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['BrowserSoft'],Trans::Translate($aDescription['BrowserSoft']),false, null, true);
      $this->aCheckVars[$project][] = array($aAgataConfig[$project]['SpreadSoft'], Trans::Translate($aDescription['SpreadSoft']), false, null, true);

    }
    
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['Project']),    false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['LoginHOST']),  false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['LoginDB']),    false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['LoginUID']),   false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['LoginPWD']),   true,  null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['Language']),   false, $aLang, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['DataBase']),   false, $aDB, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['Theme']),      false, $aTheme, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['PsSoft']),     false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['TxtSoft']),    false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['BrowserSoft']),false, null, true);
    $this->aCheckVars['+'][] = array('', Trans::Translate($aDescription['SpreadSoft']), false, null, true);    

    $this->CheckMyVars = new MultiFormEntry('images/setup.xpm', Trans::Translate('DataBase Connection Setup'),
                                       $this->aCheckVars, true,'* ' . Trans::Translate('Loaded from config.php'));
				       
    foreach ($Projects as $project)
    {
      $this->CheckMyVars->buttons[$project]->connect_object('clicked', array(&$this,'ReturnVars'), $project);
      $this->CheckMyVars->buttonsd[$project]->connect_object('clicked', array(&$this,'DeleteProject'), $project);
    }

    $this->CheckMyVars->buttons['+']->connect_object('clicked', array(&$this,'ReturnVars'), '+');
    
    $this->CheckMyVars->Show();

    $this->aAgataConfig = &$aAgataConfig;
    $this->aDescription = $aDescription;
  }
  
  function DeleteProject($project)
  {
    $this->aAgataConfig[$project] = null;
    $this->GravaConfig($project, $this->setupScreenLanguage);
  }

  function ReturnVars($project)
  {
    $aInputEntries = $this->CheckMyVars->InputEntries;

    $this->aAgataConfig[$project]['Project']   = $aInputEntries[$project][0]->get_text();
    $this->aAgataConfig[$project]['LoginHOST'] = $aInputEntries[$project][1]->get_text();
    $this->aAgataConfig[$project]['LoginDB']   = $aInputEntries[$project][2]->get_text();
    $this->aAgataConfig[$project]['LoginUID']  = $aInputEntries[$project][3]->get_text();
    $this->aAgataConfig[$project]['LoginPWD']  = $aInputEntries[$project][4]->get_text();

    $a = $aInputEntries[$project][5]->entry;
    $this->aAgataConfig[$project]['Language']  = $a->get_text();

    $b = $aInputEntries[$project][6]->entry;
    $this->aAgataConfig[$project]['DataBase']  = $b->get_text();

    $c = $aInputEntries[$project][7]->entry;
    $this->aAgataConfig[$project]['Theme']       = $c->get_text();
    $this->aAgataConfig[$project]['PsSoft']      = $aInputEntries[$project][8]->get_text();
    $this->aAgataConfig[$project]['TxtSoft']     = $aInputEntries[$project][9]->get_text();
    $this->aAgataConfig[$project]['BrowserSoft'] = $aInputEntries[$project][10]->get_text();
    $this->aAgataConfig[$project]['SpreadSoft']  = $aInputEntries[$project][11]->get_text();

    $this->aAgataConfig['defaultConfiguration'] = $project;

    if ($this->aAgataConfig[$project]['Theme'] != 'No theme') 
      Gtk::rc_parse('./themes/'. $this->aAgataConfig[$project]['Theme'] .'/gtk/gtkrc');
      
    Trans::SetLanguage($this->aAgataConfig[$project]['Language']);

    $this->GravaConfig($project);

    // Check DataBase
    $conn = new Connection;
    $Pass = $conn->Open();
    $conn->Close();

    if ($Pass)
    {
      $MainModule = new MainModule($this->aAgataConfig, $this->aDescription);
    }
    else
    {
      $tmp = new Dialog;
      $tmp->Aviso(Trans::Translate('Cannot connect to Database'), false);
    }
  }

  function GetDirArray($sPath)
  {
    $handle=opendir($sPath);
    while ($file = readdir($handle))
    {
      $nPath = "$sPath/$file";
      if (is_dir($nPath) && ($file != '.') && ($file != '..'))
      {
        $dirs[' ' . $file] = $file;
      }
    }
    closedir($handle);
    ksort($dirs);
    return $dirs;
  }
}


//Gtk::rc_parse('./AquaGraphite/gtk/gtkrc');
$agapp = new AgataMain(&$aAgataConfig, $aDescription, $setupScreenLanguage);
Gtk::main();
?>
