<?
set_time_limit(120);

/**
 *
 */
class Query
{
  var $conn;     // the connection id
  var $sql;      // the SQL command string
  var $result;   // the SQL command result set
  var $row;      // the current row index
  var $db;
  var $TableInfo;

  function Open($db)
  {
    $this->result=$db->query($this->sql);
    $this->TableInfo = null;
//    var_dump($this->result);

    if (DB::isError($this->result) || (!$this->result))
    {
      $tmp = new Dialog;
      $tmp->Aviso($this->result->getMessage());
      $this->result =0;
      return false;
    }

    return true;
  }

  function GetRowCount()
  {
    return $this->result->numRows();
  }

  function GetColumnCount()
  {
    if (!$this->result)
      echo "error \n";

    return $this->result->numCols();
  }

  function GetColumnNames()
  {
    if (!$this->TableInfo)
    {
      $this->TableInfo = $this->result->TableInfo();
    }
    $Results = $this->TableInfo;
    
    foreach ($Results as $Result)
    {
      $strings[] = $Result['name'];
    }
    return $strings;
  }

  function GetColumnTypes()
  {
    if (!$this->TableInfo)
    {
      $this->TableInfo = $this->result->TableInfo();
    }
    $Results = $this->TableInfo;

    foreach ($Results as $Result)
    {
      $strings[] = $Result['type'];
    }
    return $strings;
  }
  
  function GetColumnTypes2()
  {
    if (!$this->TableInfo)
    {
      $this->TableInfo = $this->result->TableInfo();
    }
    $Results = $this->TableInfo;

    foreach ($Results as $Result)
    {
      $strings[$Result['name']] = $Result['type'];
    }
    return $strings;
  }  

};

/**
 *
 */
class Connection
{
  var $db;         // the connection identifier
  var $traceback;  // a list of transaction errors
  var $level;      // a counter for the transaction level

  function Open($no_assert=false)
  {
    global $SessionAuth,$aAgataConfig;
    $default = $aAgataConfig['defaultConfiguration'];

    $LoginUID  = $aAgataConfig[$default]['LoginUID'];
    $LoginPWD  = $aAgataConfig[$default]['LoginPWD'];
    $LoginDB   = $aAgataConfig[$default]['LoginDB'];
    $LoginHOST = $aAgataConfig[$default]['LoginHOST'];
    $DataBase  = $aAgataConfig[$default]['DataBase'];
    require_once 'DB.php';
    $dsn="$DataBase://$LoginUID:$LoginPWD@$LoginHOST/$LoginDB";
    $this->db = DB::connect($dsn);

    if(DB::isError($this->db))
    {
      echo ($this->db->getMessage());
      $this->db = null;
      return false;
    }

    return $this->db;
  }

  function Close()
  {
    if ( $this->db )
    {
      //$this->db->disconnect();
      $this->db = null;
    }
  }

  function GetError()
  {
    if(DB::isError($db))
    {
      return $db->getMessage();
    }
  }

  function CreateQuery($sql="")
  {
    $q = new Query;

    $q->conn   = $this->db;
    $q->sql    = $sql;
    $q->result = 0;
    $q->row    = -1;

    if ( $sql != "" )
      $q->Open($this->db);

    return $q;
  }
  
  function LoadFields($table)
  {
    global $aAgataConfig;
    $default = $aAgataConfig['defaultConfiguration'];
    $DataBase = $aAgataConfig[$default]['DataBase'];
    $table = trim($table);

    $sql['pgsql']  = "SELECT * FROM $table limit 1";
    $sql['mysql']  = "SELECT * FROM $table limit 1";
    $sql['oracle'] = "SELECT * FROM $table limit 1";
    $sql['sybase'] = "SELECT * FROM $table limit 1";
    $sql['mssql']  = "SELECT COLUMN_NAME AS name FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '$table' ORDER BY COLUMN_NAME";
    $sql['fbsql']  = "SELECT * FROM $table limit 1";
    $sql['ibase']  = "select RDB\$FIELD_NAME as name from RDB\$RELATION_FIELDS " .
                     "where RDB\$RELATION_NAME = '$table' order by RDB\$FIELD_NAME ";
    $sql['ifx']    = "select c.colname from systables t, syscolumns c " .
                     "where t.tabid = c.tabid and t.tabname = '$table' order by colname ";
    $sql['odbc']   = "select name from sysibm.syscolumns where tbname='$table'";

    $sql = $sql[$DataBase];
    $Results = $this->db->query($sql);

    if (($DataBase == "ibase") || ($DataBase == "mssql") || ($DataBase == "ifx")  || ($DataBase == "odbc"))
    {
      while ($Row = $Results->fetchRow())
      {
        $strings[] = trim($Row[0]);
      }
    }
    else
    {
      foreach ($Results->TableInfo() as $Result)
      {
        $strings[] = $Result['name'];
      }
    }

    return $strings;
  }

  function LoadTables()
  {
    global $aAgataConfig;
    $default = $aAgataConfig['defaultConfiguration'];
    $DataBase = $aAgataConfig[$default]['DataBase'];

    $TableNamesQuery['pgsql']  = "select tablename from pg_tables where tablename not like 'pg%' order by tablename";
    $TableNamesQuery['mysql']  = "SHOW TABLES";
    $TableNamesQuery['oracle'] = "SELECT table_name FROM user_tables";
    $TableNamesQuery['sybase'] = "select name from sysobjects where type = 'U' order by name";
    $TableNamesQuery['mssql']  = "select name from sysobjects where type = 'U' order by name";
    $TableNamesQuery['fbsql']  = "select \"table_name\" from information_schema.tables";
    $TableNamesQuery['ibase']  = "select RDB\$RELATION_NAME from RDB\$RELATIONS where RDB\$SYSTEM_FLAG=0 and RDB\$VIEW_BLR is null order by RDB\$RELATION_NAME";
    $TableNamesQuery['ifx']    = "select tabname from systables where tabid > 99 order by tabname";
    $TableNamesQuery['odbc']    = "select name from sysibm.systables where name not like 'SYS%' and type='T'";

    $sql = $TableNamesQuery[$DataBase];
    if ($sql)
    {
      $Result = $this->db->query($sql);
      while ($Row = $Result->fetchRow())
      {
        $strings[] = trim($Row[0]);
      }
      return $strings;
    }
    else
    {
      return null;
    }
  }


};
?>
